summary refs log tree commit diff
path: root/pkgs/build-support/setup-hooks/enable-coverage-instrumentation.sh
diff options
context:
space:
mode:
Diffstat (limited to 'pkgs/build-support/setup-hooks/enable-coverage-instrumentation.sh')
-rw-r--r--pkgs/build-support/setup-hooks/enable-coverage-instrumentation.sh17
1 files changed, 17 insertions, 0 deletions
diff --git a/pkgs/build-support/setup-hooks/enable-coverage-instrumentation.sh b/pkgs/build-support/setup-hooks/enable-coverage-instrumentation.sh
index 08ef490e2447..7175b408b02f 100644
--- a/pkgs/build-support/setup-hooks/enable-coverage-instrumentation.sh
+++ b/pkgs/build-support/setup-hooks/enable-coverage-instrumentation.sh
@@ -1,3 +1,5 @@
+postPhases+=" cleanupBuildDir"
+
 # Force GCC to build with coverage instrumentation.  Also disable
 # optimisation, since it may confuse things.
 export NIX_CFLAGS_COMPILE="$NIX_CFLAGS_COMPILE -O0 --coverage"
@@ -12,3 +14,18 @@ postUnpack() {
         substituteInPlace $i --replace '*.$objext)' '*.$objext | *.gcno)'
     done
 }
+
+# Get rid of everything that isn't a gcno file or a C source file.
+# Also strip the `.tmp_' prefix from gcno files.  (The Linux kernel
+# creates these.)
+cleanupBuildDir() {
+    if ! [ -e $out/.build ]; then return; fi
+
+    find $out/.build/ -type f -a ! \
+        \( -name "*.c" -o -name "*.cc" -o -name "*.cpp" -o -name "*.h" -o -name "*.hh" -o -name "*.y" -o -name "*.l" -o -name "*.gcno" \) \
+        | xargs rm -f --
+
+    for i in $(find $out/.build/ -name ".tmp_*.gcno"); do
+        mv "$i" "$(echo $i | sed s/.tmp_//)"
+    done
+}